void cb_arrow(Fl_Widget *w, void *v)
{
	long int r;
	r=(long int)v;
	switch(r){
		case ARR_LEFT: main_win->view->Aktzeit-=main_win->view->Zoom/4; break;
		case ARR_RIGHT: main_win->view->Aktzeit+=main_win->view->Zoom/4; break;
		case ARR_UP: main_win->view->offset+=main_win->view->Scale/10; break;
		case ARR_DOWN: main_win->view->offset-=main_win->view->Scale/10; break;
		case ARR_ZOOMIN: main_win->view->Zoom/=2; break;
		case ARR_ZOOMOUT: main_win->view->Zoom*=2; break;
	}
	//main_win->canvas->redraw();
	main_win->redraw();
	//main_win->bt_left->redraw();
	//main_win->bt_right->redraw();
	//main_win->bt_up->redraw();
	//main_win->bt_down->redraw();
}

void cb_settings(Fl_Widget *w, void *v)
{
	char st1[50];
	int r;
	ui->fontsize->value(main_win->view->sizeFont);
	sprintf(st1,"%6.2lf",main_win->view->Zoom);
	ui->zoom->value(st1);
	sprintf(st1,"%6.2lf",main_win->view->Scale);
	ui->scale->value(st1);
	ui->settings->show();
	ui->settings->position(main_win->x()+20,main_win->y()+20);
	while (ui->settings->visible()) Fl::wait();
	main_win->view->sizeFont=ui->fontsize->value();
	r=sscanf(ui->zoom->value(),"%lf",&main_win->view->Zoom);
	r=sscanf(ui->scale->value(),"%lf",&main_win->view->Scale);
	main_win->size(main_win->w(),main_win->h());
	main_win->redraw();
}


void cb_fileOpen(Fl_Widget *w, void *v)
{
	char st1[PATH_MAX],*cp;
	strcpy(st1,"");
	cp=fl_file_chooser("select source file","*.csv*",st1,0);
	if(cp) FileOpen(main_win->view,cp);
}



myWindow::myWindow(int w, int h, const char *st): Fl_Window(400,400,w,h,st) {
	view=(myView*)calloc(sizeof(myView),1);
	menu=new Fl_Menu_Bar(0, 0, 400, 20);
	menu->add("File/&Open",0,cb_fileOpen);
	menu->add("File/&Print", 0, cb_print);
	menu->add("File/&Write PS", 0, cb_ps);
	menu->add("File/&Quit", 0, cb_quit);
	menu->add("View/Zoom &in",0,cb_arrow,(void*)ARR_ZOOMIN);
	menu->add("View/Zoom &out",0,cb_arrow,(void*)ARR_ZOOMOUT);
	menu->add("Edit/Settings",0,cb_settings);
	canvas=new myCanvas(0,40,w,h-80);
	canvas->user_data(0);
	xpm_up=new Fl_Pixmap(up_xpm);
	xpm_down=new Fl_Pixmap(down_xpm);
	xpm_left=new Fl_Pixmap(left_xpm);
	xpm_right=new Fl_Pixmap(right_xpm);
	bt_up=new Fl_Button(50,50,20,20);
	bt_up->image(xpm_up);
	bt_up->callback(cb_arrow,(void*)ARR_UP);
	bt_down=new Fl_Button(150,50,20,20);
	bt_down->image(xpm_down);
	bt_down->callback(cb_arrow,(void*)ARR_DOWN);
	bt_left=new Fl_Button(250,50,20,20);
	bt_left->image(xpm_left);
	bt_left->callback(cb_arrow,(void*)ARR_LEFT);
	bt_right=new Fl_Button(350,50,20,20);
	bt_right->image(xpm_right);
	bt_right->callback(cb_arrow,(void*)ARR_RIGHT);
	status=new Fl_Box(0,h-20,w,20);
	status->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
	strcpy(view->windowTitle,"csv-Viewer");
	label(view->windowTitle);
	end();
	}

void myWindow::resize(int x, int y, int w, int h) {
	Fl_Window::resize(x,y,w,h);
	menu->resize(0,0,w,20);
	canvas->resize(0,20,w,h-40);
	status->resize(0,h-20,w,20);
	bt_down->resize(25,view->yPalette-25,20,20);
	bt_left->resize(5,view->yPalette-35,20,20);
	bt_right->resize(45,view->yPalette-35,20,20);
	bt_up->resize(25,view->yPalette-45,20,20);
	}
